﻿Public Class Form1

    Dim list_z, list_y As List(Of DataList)


    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        Me.c1FlexGrid1.Cols.Count = 5
        Me.c1FlexGrid1.Rows.Count = 10

        'Populate the grid
        For _row As Integer = Me.c1FlexGrid1.Rows.Fixed To Me.c1FlexGrid1.Rows.Count - 1
            For _col As Integer = Me.c1FlexGrid1.Rows.Fixed To Me.c1FlexGrid1.Cols.Count - 1
                Me.c1FlexGrid1(_row, _col) = String.Format("{0},{1}", _row, _col)
            Next
        Next

        list_z = New List(Of DataList)()
        list_y = New List(Of DataList)()

        'let the grid handle clipboard operations
        Me.c1FlexGrid1.AutoClipboard = True
    End Sub

    'Save original cell values to list before a new value gets pasted
    Private Sub c1FlexGrid1_KeyDown(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles c1FlexGrid1.KeyDown

        If e.KeyData = (Keys.Control Or Keys.V) Then
            Dim row As Integer = Me.c1FlexGrid1.Row
            Dim col As Integer = Me.c1FlexGrid1.Col
            Dim value As String = Me.c1FlexGrid1.GetData(row, col).ToString()
            list_z.Add(New DataList() With {.Row = row, .Col = col, .Text = value})
        End If

    End Sub

    'Add values to "list" object as grid's contents get changed.
    Private Sub c1FlexGrid1_ValidateEdit(sender As Object, e As C1.Win.C1FlexGrid.ValidateEditEventArgs) Handles c1FlexGrid1.ValidateEdit

        list_z.Add(New DataList() With {.Row = e.Row, .Col = e.Col, .Text = Me.c1FlexGrid1(e.Row, e.Col).ToString()})

    End Sub
    Private Sub c1FlexGrid1_KeyUp(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles c1FlexGrid1.KeyUp

        'Undo changes
        If (e.KeyData = (Keys.Control Or Keys.Z) AndAlso list_z.Count <> 0) Then
            'Iterate the list object from bottom to top; and fetch row,col and text
            'save the same value to the same row,col of the grid
            Dim row As Integer = list_z(list_z.Count - 1).Row
            Dim col As Integer = list_z(list_z.Count - 1).Col
            Dim value As String = list_z(list_z.Count - 1).Text

            'Add new cell values to Redo list
            list_y.Add(New DataList() With {.Row = row, .Col = col, .Text = Me.c1FlexGrid1(row, col).ToString()})

            'Save original cell value to the grid and set focus to the cell                
            Me.c1FlexGrid1(row, col) = value
            Me.c1FlexGrid1.Row = row
            Me.c1FlexGrid1.Col = col
            'remove last element from the list
            list_z.RemoveAt(list_z.Count - 1)

            'Redo changes
        ElseIf (e.KeyData = (Keys.Control Or Keys.Y) AndAlso list_y.Count <> 0) Then
            Dim row As Integer = list_y(list_y.Count - 1).Row
            Dim col As Integer = list_y(list_y.Count - 1).Col
            Dim value As String = list_y(list_y.Count - 1).Text

            'Add existing values to Undo list
            list_z.Add(New DataList() With {.Row = row, .Col = col, .Text = Me.c1FlexGrid1(row, col).ToString()})

            'Save original cell value to the grid and set focus to the cell                
            Me.c1FlexGrid1(row, col) = value
            Me.c1FlexGrid1.Row = row
            Me.c1FlexGrid1.Col = col
            'remove last element from the list
            list_y.RemoveAt(list_y.Count - 1)
        End If
    End Sub
End Class

' Storag Class
Public Class DataList
    Private _row As Integer
    Private _col As Integer
    Private _text As String

    Public Property Row() As Integer
        Get
            Return _row
        End Get
        Set(value As Integer)
            _row = value
        End Set
    End Property

    Public Property Col() As Integer
        Get
            Return _col
        End Get
        Set(value As Integer)
            _col = value
        End Set
    End Property

    Public Property Text() As String
        Get
            Return _text
        End Get
        Set(value As String)
            _text = value
        End Set
    End Property
End Class


